<?php

namespace Controller;

use Util\Utilities;
use Util\Instance\ServiceInstance;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class Language
{
    /**
     * @param Request\Filter $request
     * @param Response $response
     */
    public function getProductLanguages(Request\Filter $request, Response $response) {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $productId  = Utilities::getValueInFilterDataSourceByName($conditions, 'PRODUCT_ID');
            $languages  = ServiceInstance::getLanguage()->getProductLanguages($productId);
            $response->addDataSet(new DataSet ('languages', $languages));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}